﻿Type=Class
Version=2.00
@EndOfDesignText@
'Class module
Sub Class_Globals
Type aliens(azmin As Double, azmax As Double,x0 As Int, y0 As Int,maxv As Double,pic As String, delay As Int,Walk As Int, Timer As Timer)
Dim R(10) As aliens
Private bck As Bitmap
Private cnvs As Canvas
Private explosion, home As ImageView
Private spsize, count(10), total(10), sp_counter As Int 
Dim xlst,ylst As List
Dim  objmap As Map
Private mp As MediaPlayer
Private Gamezone As Panel
Private spr(200) As Sprite
Private ExplosionTimer As Timer
End Sub

'Initializes the Game object. 
Sub Initialize(BackGround As String)
Gamezone.Initialize("")
bck.Initialize(File.DirAssets,BackGround)
If BackGround <> Null Then Gamezone.SetBackgroundImage(bck)
objmap.Initialize
mp.Initialize

spsize = Max(100%x,100%y) * 0.05
sp_counter = 0
explosion.Initialize("")
Gamezone.AddView(explosion,1600,0,spsize,spsize)
explosion.Gravity = Gravity.FILL
explosion.SetBackgroundImage(LoadBitmap(File.DirAssets,"explosion.png"))
ExplosionTimer.Initialize("ExplosionTimer",700)
home.Initialize("")
Gamezone.AddView(home,150%x,50%y,spsize,spsize)
home.Gravity = Gravity.FILL
home.SetBackgroundImage(LoadBitmap(File.DirAssets,"goal.png"))
End Sub

Sub AsView As View
Return Gamezone
End Sub

'Define the specific behaviour of a type of sprite.
' Walkmode can be 0 for free_flyer or 1 for path_walker.
' Index is the number of the type.
' x0 and y0 define the starting point of this type of sprites.
' Maxv is the maximal velocity of the sprite.
' azmin and azmax - define the azimuth range for this type, if it is a free_flyer.
' pic is the filename of the animated GIF of the Sprite.
' delay is the interval of the animated GIF timer.
' Interval is the time interval between sprites in the launched group.
Sub setType(WalkMode As Int,index As Int, x0 As Int, y0 As Int, maxv As Double, azmin As Double, azmax As Double, pic As String, delay As Int, Interval As Int )
R(index).Initialize
R(index).Walk = WalkMode
R(index).x0 = x0
R(index).y0 = y0
R(index).maxv = maxv
R(index).azmin = azmin
R(index).azmax = azmax
R(index).pic = pic
R(index).delay = delay
R(index).Timer.Initialize("LaunchTimer", Interval + index)
End Sub

'Set the path for the path_walker stripes, by two arrays of x and y coordinates.
Sub setPath(list_x As List, list_y As List)
xlst = list_x
ylst = list_y
End Sub

'Draws the path using start point, color and width of line.
Sub draw_path(x0 As Int,y0 As Int, color As Int, StrokeWidth As Float)
If xlst.IsInitialized = False OR ylst.IsInitialized = False Then Return
cnvs.Initialize(Gamezone)
cnvs.DrawLine(xlst.Get(0),ylst.Get(0),x0,y0,color,StrokeWidth)
For i = 0 To xlst.Size - 2
	cnvs.DrawLine(xlst.Get(i), ylst.Get(i),xlst.Get(i+1),ylst.Get(i+1),color,StrokeWidth)
Next
home.Left = xlst.Get(xlst.Size-1) - spsize/2
home.top = ylst.Get(ylst.Size-1) - 2*spsize/3
End Sub

'Launches a group of quantity of sprites of type index
Sub LaunchGroup(index As Int, quantity As Int)
If R(index).timer.Enabled = True Then Return
If R(index).Walk = 1 AND (xlst.IsInitialized = False OR ylst.IsInitialized = False) Then Return
total(index) = quantity
count(index) = 0
R(index).timer.Enabled = True
End Sub

Private Sub launchOne(index As Int)
Dim temp As Double
spr(sp_counter).Initialize(Me, Gamezone, index)
Gamezone.AddView(spr(sp_counter).AsView, R(index).x0 -spsize/2, R(index).y0-spsize/2, spsize, spsize)
End Sub

Private Sub LaunchTimer_tick
Dim t As Timer
Dim k As Int
t = Sender
k = t.Interval/10
k = t.Interval - k * 10
sp_counter = sp_counter + 1
count(k) = count(k) + 1
Try
	launchOne(k)
Catch
	count(k) = count(k) - 1
End Try
If count(k) = total(k) Then R(k).Timer.Enabled = False
End Sub

'Updates a map which holds the existing sprites.
Sub UpdateSprite(tsp As Sprite)
objmap.Put(tsp,sp_counter)
End Sub

'Checks if collision situation between two different type sprites exists.
Sub CheckCollision(tsp As Sprite)
Dim tsp1 As Sprite
For i = 0 To objmap.Size -1
	tsp1 = objmap.GetkeyAt(i)
	If tsp <> tsp1 Then
		If tsp.myindex <> tsp1.myindex Then
			If Abs(tsp.S.x - tsp1.S.x) < tsp.spview.Width/3 AND _
			   Abs(tsp.S.y -tsp1.S.y) < tsp.spview.height/3	Then
	 			   explode(tsp,tsp1)
				   Exit
			End If
		End If
	End If
Next
End Sub

'Show explosion at the collision point and remove the two sprites.
Sub explode(tsp1 As Sprite, tsp2 As Sprite)
mp.Load(File.DirAssets,"explosion.wav")
mp.play
explosion.Left = tsp1.S.x - explosion.Width/2
explosion.Top = tsp1.S.y - explosion.Height/2
ExplosionTimer.enabled = True
RemoveSprite(tsp1)
If tsp2 <> Null Then RemoveSprite(tsp2)
End Sub

'Removes a sprite.
Sub RemoveSprite(tsp As Sprite)
tsp.sptmr.Enabled = False
tsp.giftmr.Enabled = False
objmap.Remove(tsp)
tsp.AsView.RemoveView
End Sub

Private Sub ExplosionTimer_tick
explosion.Left = 1600
ExplosionTimer.Enabled = False
End Sub

